# Documentation Sandbox
## How-to pas à pas
1. Démarrer la machine, attendre d'être connecté automatiquement sur le compte `sandbox`.
2. Une fois le bureau affiché, cliquer sur "Activities" en haut à gauche de l'écran.
3. Dans la barre de recherche, taper `settings` et ouvrir les paramètres du système (Application `settings`).
4. Cliquer sur "Displays". Au milieu, deux petites images d'écran numérotées 1 et 2 sont présentent correspondant aux affichages. Vérifier que le beamer ("Sanyo [...]") soit placé à gauche. Si ce n'est pas le cas, cliquer sur l'illustration de l'écran et le glisser à gauche.
5. Avec le beamer sélectionné, vérifier la résolution d'affichage (`1400x1050` ou `1024x768`).
6. Appliquer la configuration en cliquant sur "Apply" vert, en haut de la fenêtre.
7. Fermer les paramètres système
8. Cliquer droit sur le bureau, "Open terminal".
9. Taper `ip -a` et vérifier que l'IP de la carte réseau `enp2s0` est bien du type 192.168.X.X et pas 169.X.X.X. Si c'est le cas, voir la FAQ à la fin de ce document.
10. Dans le terminal, taper la commande suivante : `systemd-inhibit ./execute_app_nds.sh`. Tout devrait se lancer.

## Configuration du poste
### 1. Configuration de l'affichage (Beamer)
Brancher le beamer à la machine, puis lancer l'utilitaire de configuration des affichages d'Ubuntu (`Settings` -> `Display`). 

Configurer le beamer sur la résolution : `1400x1050` ou `1024x768`

Placer le beamer à gauche, l'écran à droite (La visualisation se lance le plus à gauche possible). Vérifier que l'écran du PC est bien configuré comme affichage principal (et pas le beamer)

> Si une application se lance sur le mauvais écran, il est possible de la déplacer avec la combinaison de touche Windows+Shift+Flèches directionnelles

## Exécuter l'application
L'exécution de l'application doit être fait à l'aide de `systemd-inhibit` pour prévenir la mise en veille. Pour exécuter le script avec l'inhibition, utiliser la commande suivante :
```bash
systemd-inhibit ./execute_app_nds.sh
```

Avant d'exécuter l'application, s'assurer de l'adresse IP du serveur avec Cinema4D, et aller renseigner l'url de la route dans le script python de l'application : `nano /home/sandbox/Desktop/NdS/demo.py` et modifier la valeur de la variable `DEFAULT_URL` pour correspondre à l'adresse de la machine avec le port et la route ou poster (Par ex : `DEFAULT_URL="http://192.168.1.100/map"`)

Un script shell (`execute_app_nds.sh`) pour démarrer l'application est présent sur le bureau du compte `sandbox`.  
```bash
cd /home/sandbox/Desktop/NdS

source /home/sandbox/python-env/.venv/bin/activate # Active l'env. virtuel python
source /home/sandbox/python-env/env.sh # Permet à ld de trouver la lib sandbox

python demo.py # Exécute l'application
```

## Effectuer la calibration
Un script shell (`calibrate.sh`) est disponible sur le bureau du compte `sandbox`. Il n'est normalement pas nécessaire de procéder à la calibration sauf après montage du bac à sable.

```bash
su admin # Enter password
sudo su # Become root

export LD_LIBRARY_PATH=/home/admin/sandbox/ar_sandbox_lib/build
cd /home/admin/sandbox/ar_sandbox_lib/app/SandboxSetup
./SandboxSetup
```

Une fois la calibration effectuée, déplacer le fichier sandbox-conf.yml généré dans le répertoire de l'application python. (Evt. effectuer un backup de l'ancienne config.)

```bash
cp /home/sandbox/Desktop/NdS/sandbox-conf.yml \ 
/home/sandbox/Desktop/NdS/sandbox-conf.bak
mv sandbox-conf.yml /home/sandbox/Desktop/NdS/sandbox-conf.yml
```



## FAQ
> Quels sont les mots de passes des différents comptes ?

|User|Password| Notes |
|--|--| -- |
|sandbox|sandbox| Ne peut pas sudo
| admin | !sandboxadmin! | sudoer |

> Le beamer s'est éteint
- Ne toucher à rien, débrancher la prise de courant du beamer (au niveau de la rallonge), attendre l'extinction de la LED de contrôle sur le beamer, puis le rebrancher. Normalement, tout devrait revenir.

> L'IP de la machine n'est pas correcte
- Se connecter sur le compte admin, et passer la carte réseau en DHCP : `sudo dhclient enp2s0`. Vérifier que l'IP reçue est bien dans le même réseau que celle de la machine Cinema4D